/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * Specifies the ResourceId of the PrintLayout to use for a particular
 * map, the title and the type of units to use in the layout.
 *
 */
 public class MgdLayout extends MgSerializable {
  private long swigCPtr;

  public MgdLayout(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgdLayoutToMgSerializable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected MgdLayout() {
    this(0, false);
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgdLayout(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgdLayout obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Initializes a new {@link MgdLayout} object given a layout definition, title and unit type.
 *
 * @param  layoutDefinition ({@link MgResourceIdentifier})  An {@link MgResourceIdentifier} that specifies the  location of the print layout definition in a resource  repository.
 * @param  title (String/string)  The title to use in the print layout
 * @param  unitType (String/string)  The type of units to use in the print layout
 * @return  Nothing
 */
 public MgdLayout(MgResourceIdentifier layoutDefinition, String title, String unitType) {
    this(MapGuideDesktopApiJNI.new_MgdLayout(MgResourceIdentifier.getCPtr(layoutDefinition), title, unitType), true);
  }

  
/**
 * Get the Layout to use when generating the EPlot DWF.  If not
 * specified, then the plotted map will fill the space within the page
 * margins.
 *
 * @return  The resource identifier for the layout definition.
 */
 public MgResourceIdentifier getLayout() {
    long cPtr = MapGuideDesktopApiJNI.MgdLayout_GetLayout(swigCPtr);
    return (cPtr == 0) ? null : (MgResourceIdentifier)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Set the Layout to use when generating the EPlot DWF.  If not
 * specified, then the plotted map will fill the space within the page
 * margins.
 *
 * @param  plotLayout ({@link MgResourceIdentifier})  An {@link MgResourceIdentifier} that specifies the  location of the print layout definition in a resource  repository.
 * @return  Nothing
 */
 public void setLayout(MgResourceIdentifier plotLayout) {
    MapGuideDesktopApiJNI.MgdLayout_SetLayout(swigCPtr, MgResourceIdentifier.getCPtr(plotLayout));
  }

  
/**
 * Gets the layout title.
 *
 * @return  Returns the title for the plot.
 */
 public String getTitle() {
  { return MapGuideDesktopApiJNI.MgdLayout_GetTitle(swigCPtr); }
}

  
/**
 * Sets the layout title.
 *
 * @param  title (String/string)  The title for the layout.
 * @return  Returns nothing.
 */
 public void setTitle(String title) {
    MapGuideDesktopApiJNI.MgdLayout_SetTitle(swigCPtr, title);
  }

  
/**
 * Gets the layout scale units (US/English or metric units).
 * This value determines the units used in the scale bar definition.
 * This value is ignored if a layout is not specified.
 *
 * @return  The layout scale units.
 */
 public String getUnitType() {
  { return MapGuideDesktopApiJNI.MgdLayout_GetUnitType(swigCPtr); }
}

  
/**
 * Gets the layout scale units (US/English or metric units).
 * This value determines the units used in the scale bar definition.
 * This value is ignored if a layout is not specified.
 *
 * @param  unitType (String/string)  The layout scale units
 * @return  Returns nothing.
 */
 public void setUnitType(String unitType) {
    MapGuideDesktopApiJNI.MgdLayout_SetUnitType(swigCPtr, unitType);
  }

}
